#ifndef HW_H
#define HW_H

#include <ftdi.h>

#define USB_VENDOR 0x8482
#define USB_DEVICE 0x1002

typedef struct hwctx {
	struct ftdi_context ftdi;
	int read_pos;
	unsigned int read_buf;
} hwctx_t;

char **hw_find_boards(void);
hwctx_t *hw_open_board(char *);
int hw_write_word(hwctx_t *, unsigned);
int hw_read_word(hwctx_t *, unsigned *, int);
int hw_chip_mask(hwctx_t *, unsigned);
int hw_irq_mask(hwctx_t *, unsigned);
int hw_write_reg(hwctx_t *, unsigned, unsigned);
int hw_read_reg(hwctx_t *, unsigned, unsigned);
int hw_xor_byte(hwctx_t *, int, unsigned char);
int hw_write_ctrl(hwctx_t *, unsigned);
int hw_led_char(hwctx_t *, int, unsigned char);
int hw_led_line(hwctx_t *, char *);
void hw_close_board(hwctx_t *);

#endif
